//
// Gewinnzahlen ziehen, Anzahl der Treffer in einem Tipp pruefen
//

import java.util.Arrays;

public class LottoGesellschaft {

	// Array fuer Gewinnzahlen
	private int[] gewinnzahlen = new int[6];
	
	// Getter
	public int[] getGewinnzahlen () {
		return gewinnzahlen;
	}
	
	// Setter: 6 zufaellige Zahlen ziehen und sortieren lassen. Es werden keine doppelten Zahlen gezogen.
	public void zieheGewinnzahlen () {
		do {
			for (int zahl = 0; zahl < 6; zahl++) {
				gewinnzahlen[zahl] = (int) (Math.random() * 49) + 1;
			}
		} while (pruefeDoppelteZahlen (gewinnzahlen) == true);
		
		// Zahlen sortieren
		Arrays.sort (gewinnzahlen);
	}
	

	// Den Wertebereich der Zahlen pruefen
	public boolean pruefeWertebereich (int[] tipp) {
		// wir gehen davon aus, dass der Wertebereich ok ist
		boolean status = true;		
		for (int zahl : tipp) {
			if (zahl < 1 || zahl > 49) {
				status = false;
			}
		}
		return status;
	}	


	// Prueft den Tipp auf doppelte Zahlen
	public boolean pruefeDoppelteZahlen (int[] tipp) {
		for (int zahl1 = 0; zahl1 < tipp.length - 1; zahl1++) {
			for (int zahl2 = zahl1 + 1; zahl2 < tipp.length ; zahl2++) {
				//System.out.println ("pruefe index " + zahl1 + " mit index " + zahl2);
				if (tipp[zahl1] == tipp[zahl2]) {
					return true;
				}
			}
		}
		return false;
	}
	

	// Diese Helfer-Methode prueft, ob eine bestimmte zahl im Array gewinnzahlen[] enthalten ist
	// Sie ist nur in der Klasse LottoGesellschaft sichtbar
	private boolean zahlIstVorhanden (int zahl) {
		for (int i : gewinnzahlen) {
			if (i == zahl) {
				return true;
			}
		}
		return false;
	}
	
	
	// Fuegen Sie eine Methode hinzu, die die Anzahl der Treffer in einem Tipp zurueckliefert.
	// Jede Zahl aus tipp[] einzeln pruefen, ob sie im Array gewinnzahlen[] enthalten ist.
	public int getAnzahlTreffer (int []tipp) {
		int anzahlTreffer = 0;

		for (int zahl : tipp) {
			if (zahlIstVorhanden (zahl)) {
				anzahlTreffer++;
			}
		}
		return anzahlTreffer;
	}
	

	// Fuegen Sie eine Methode hinzu, die die Anzahl der Treffer in einem Tipp zurueckliefert.
	// Jede Zahl aus tipp[] einzeln pruefen, ob sie im Array gewinnzahlen[] enthalten ist.
	// Die Treffer sollen in einem Array passender Groesse zurckgeliefert werden.
	public int[] getTreffer (int []tipp) {
		int treffer[] = new int[tipp.length];	// Array hat dieselbe Laenge wie tipp[]
		int anzahlTreffer = 0;
		
		for (int zahl = 0; zahl < tipp.length; zahl++) {
			if ( zahlIstVorhanden (tipp[zahl]) ) {
				treffer[anzahlTreffer] = tipp[zahl];	// Treffer speichern
				anzahlTreffer++;
			}
		}

		// ein Array passender Groesse erzeugen und die Treffer-Zahlen kopieren
		int ergebnis[] = new int[anzahlTreffer];
		for (int zahl = 0; zahl < anzahlTreffer; zahl++) {
			ergebnis[zahl] = treffer[zahl];
		}
			
		return ergebnis;						// die Referenz auf das Array mit Treffern zurueckliefern
	}
}